#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <time.h>

#pragma pack(2)

// at start, bp points to the buffer, bitc is zero (most significant bit), ubuf has a URL, len has length of buffer in bytes

unsigned char *bp, bitc;
unsigned short len;

FILE *ofp;

extern void dobitmap();

static inline int bitget()
{
  register unsigned char t;

  //  if (!len && bitc == 7)
  //   exit(-1);

  t = 1 & (*bp >> (7 - bitc++));
  if (bitc == 8)
    bp++, bitc = 0, len--;
#ifdef debug
  fprintf(ofp, "%d", t);
#endif
  return t;
}

static inline int getbits(int n)
{
  int t8 = 0;
#ifdef debug
  fprintf(ofp, "[");
#endif
  while (n--) {
    t8 <<= 1;
    t8 |= bitget();
  }
#ifdef debug
  fprintf(ofp, "]");
#endif
  return t8;
}

#include "/usr/local/palmdev/sdk/include/Core/System/CMLConst.h"

unsigned long varint()
{
  register unsigned long u32 = 0;
  register int n = 0;

#ifdef debug
  fprintf(ofp, "[");
#endif
  while (bitget())
    n++;
#ifdef debug
  fprintf(ofp, "(%d)", n);
#endif
  if (!n)
    return 0;
  else if (n == 1)
    n = 3;
  else if (n == 2)
    n = 6;
  else if (n == 3)
    n = 16;
  else
    n = 32;
  while (n--) {
    u32 <<= 1;
    u32 |= bitget();
  }
#ifdef debug
  fprintf(ofp, "(%ld)]", u32);
#endif
  return u32;
}


unsigned char ubuf[1024];

#define push(s) strcpy(tagstk[tsptr++],(s))

void printtran(char t8)
{
  if (t8 == '<')
    fprintf(ofp, "&lt;");
  else if (t8 == '>')
    fprintf(ofp, "&gt;");
  else
    fprintf(ofp, "%c", t8);
}

void dohtml(char *fname)
{
  char tagstk[128][20];
  int tsptr = 0;
  int bytes = 0;
  unsigned char t5, t8, tx;
  unsigned long u32;

  fprintf(ofp, "<html><head><title>\n");
  push("</html>");
  push("</body>");
  push("</title>");

  while (len) {

    if (bytes) {
      t8 = getbits(8);
      if (t8)
        printtran(t8);
      else {
        bytes = 0;
      }
      continue;
    } else
      t5 = getbits(5);

    switch (t5) {
    case 0:
      if (len < 2)
        len = 0;
      if (tsptr) {
        fprintf(ofp, "%s", tagstk[--tsptr]);
        if (!strcmp("</title>", tagstk[tsptr])) {
          fprintf(ofp,
                  "\n<META NAME=PalmComputingPlatform CONTENT=\"true\">\n");
          fprintf(ofp, "<META NAME=LocalIcon CONTENT=\"%s\">\n", ubuf);
          // peek for history meta tag to close head if not there
          {
            char *bpt = bp, bcnt = bitc;
            int lcn = len;

            if (getbits(5) != 1 || getbits(8) != cmlTagHistoryListText)

              fprintf(ofp, "</head><body>");
            bp = bpt;
            bitc = bcnt;
            len = lcn;
          }

        }
      } else
        fprintf(ofp, "\nUNDERFLOW]\n");
#if 1
      if (strlen(tagstk[tsptr + 1]) == 1
          || (tagstk[tsptr + 1][0] == '<' && tagstk[tsptr + 1][1] == '/'
              && tagstk[tsptr + 1][strlen(tagstk[tsptr + 1]) - 1] == '>'))
        fprintf(ofp, "\n");
#endif
      bytes = 0;
      break;
    case 2:
      printtran(getbits(8));
      break;
    case 3:
      fprintf(ofp, "\n<br><br>\n");
      break;
    case 4:
      fprintf(ofp, "\n<BR>\n");
      break;
    case 5:
      fprintf(ofp, " ");
      break;
    default:
      fprintf(ofp, "%c", t5 + 'a' - 6);
      break;

    case 1:

      t8 = getbits(8);
      switch (t8) {

      default:
        fprintf(ofp, "\nunhandled tag %02x\n", t8);
        break;

      case cmlTagBGColor:
        fprintf(ofp, "<BODY bgcolor=\"#");
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x\">", getbits(8));
        break;

      case cmlTagTextColor:
        fprintf(ofp, "<FONT color=\"#");
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x\">", getbits(8));
        break;

      case cmlTagLinkColor:
        fprintf(ofp, "<BODY");
        switch (getbits(2)) {
        case cmlLinkColor:
          fprintf(ofp, " link=\"#");
          break;
        case cmlLinkColorVisited:
          fprintf(ofp, " vlink=\"#");
          break;
        case cmlLinkColorActive:
          fprintf(ofp, " alink=\"#");
          break;
        }
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x", getbits(8));
        fprintf(ofp, "%02x\">", getbits(8));
        break;

      case cmlTagTextSize:
        t8 = getbits(3);
#if 0
        if (t8 == 3)
          fprintf(ofp, "</font>");
        else
#endif
          fprintf(ofp, "<font size=%d>", t8);
        break;

      case cmlTagTextBold:
        fprintf(ofp, "<B>");
        push("</b>");
        break;
      case cmlTagTextItalic:
        fprintf(ofp, "<i>");
        push("</i>");
        break;
      case cmlTagTextStrike:
        fprintf(ofp, "<Strike>");
        push("</strike>");
        break;
      case cmlTagTextMono:
        fprintf(ofp, "<TT>");
        push("</tt>");
        break;
      case cmlTagTextSup:
        fprintf(ofp, "<Sup>");
        push("</sup>");
        break;
      case cmlTagTextSub:
        fprintf(ofp, "<Sub>");
        push("</sub>");
        break;
      case cmlTagTextUnderline:
        fprintf(ofp, "<U>");
        push("</u>");
        break;

      case cmlTag8BitEncoding:
        bytes = 1;
        break;

      case cmlTagH1:
      case cmlTagH2:
      case cmlTagH3:
      case cmlTagH4:
      case cmlTagH5:
      case cmlTagH6:
        fprintf(ofp, "<H%d", 1 + t8 - cmlTagH1);
        sprintf(tagstk[tsptr++], "</h%d>", 1 + t8 - cmlTagH1);
        if (getbits(1)) {
          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " align=left");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " align=center");
            break;
          case cmlAlignRight:
            fprintf(ofp, " align=right");
            break;
          }
        }

        fprintf(ofp, ">");
        break;

      case cmlTagHistoryListText: // 0x18
        fprintf(ofp, "<meta name=HistoryListText content=\"");
        push("\">\n</head><body>");
        break;

      case cmlTagParagraphAlign: // 0x08
        switch (getbits(2)) {
        case cmlAlignLeft:
          fprintf(ofp, "<P align=left>");
          break;
        case cmlAlignCenter:
          fprintf(ofp, "<P align=center>");
          break;
        case cmlAlignRight:
          fprintf(ofp, "<P align=right>");
          break;
        }
        break;

      case cmlTagBlockQuote:   // 0x10
        fprintf(ofp, "<BlockQuote>");
        push("</blockquote>");
        break;

      case cmlTagAddress:
        fprintf(ofp, "<Address>");
        push("</address>");
        //Text
        break;




      case cmlTagListOrdered:
        fprintf(ofp, "<OL");
        switch (getbits(3)) {
        case cmlListT1:
          fprintf(ofp, " type=1");
          break;
        case cmlListTa:
          fprintf(ofp, " type=a");
          break;
        case cmlListTA:
          fprintf(ofp, " type=A");
          break;
        case cmlListTi:
          fprintf(ofp, " type=i");
          break;
        case cmlListTI:
          fprintf(ofp, " type=I");
          break;
        }

        fprintf(ofp, " start=%ld>", varint() + 1);
        push("</ol>");
        break;


      case cmlTagListUnordered:
        fprintf(ofp, "<UL");
        switch (getbits(3)) {
        case cmlListTDisc:
          fprintf(ofp, " type=Disc>");
          break;
        case cmlListTSquare:
          fprintf(ofp, " type=Square>");
          break;
        case cmlListTCircle:
          fprintf(ofp, " type=Circle>");
          break;
        }
        push("</ul>");
        break;


      case cmlTagListDefinition:
        fprintf(ofp, "<DL>");
        push("</dl>");
        break;
      case cmlTagListItemNormal:
        fprintf(ofp, "\n<LI>");
        break;

      case cmlTagListItemCustom:
        fprintf(ofp, "\n<LI");
        tx = getbits(2);
        if (tx & 1) {
          switch (getbits(3)) {
          case cmlListT1:
            fprintf(ofp, " type=1");
            break;
          case cmlListTa:
            fprintf(ofp, " type=a");
            break;
          case cmlListTA:
            fprintf(ofp, " type=A");
            break;
          case cmlListTi:
            fprintf(ofp, " type=i");
            break;
          case cmlListTI:
            fprintf(ofp, " type=I");
            break;
          case cmlListTDisc:
            fprintf(ofp, " type=Disc");
            break;
          case cmlListTSquare:
            fprintf(ofp, " type=Square");
            break;
          case cmlListTCircle:
            fprintf(ofp, " type=Circle");
            break;
          }

        }
        if (tx & 2)
          fprintf(ofp, " value=%ld", varint() - 1);

        fprintf(ofp, ">");
        break;

      case cmlTagListItemTerm:
        fprintf(ofp, "<dt>");
        break;

      case cmlTagListItemDefinition: // 0x20
        fprintf(ofp, "<dd>");
        break;



      case cmlTagForm:
        fprintf(ofp, "<Form ");
        push("</form>");
        u32 = varint();         //index
        t8 = getbits(3);        //local:secure:standalone
        if (t8 & 1) {
          fprintf(ofp, " METHOD=%s", getbits(1) ? "POST" : "GET");
          fprintf(ofp, " ENCTYPE=\"");
          push("\">");
          //implied - needed most places.
          push("application/x-www-form-urlencoded\" ACTION=\"");

        } else
          fprintf(ofp, ">");

        break;

      case cmlTagInputTextLine:
      case cmlTagInputPassword:

        fprintf(ofp, "<Input");
        if (t8 == cmlTagInputTextLine)
          fprintf(ofp, " type=text");
        if (t8 == cmlTagInputPassword)
          fprintf(ofp, " type=password");

        fprintf(ofp, " size=%ld", varint());
        fprintf(ofp, " maxlength=%ld", varint());

        t8 = getbits(2);
        if (t8) {
          if (t8 & 1) {
            fprintf(ofp, " name=\"");
            push("\">");
            if (t8 & 2)
              push("\" value=\"");
          } else {
            fprintf(ofp, " value=\"");
            push("\">");
          }
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputCheckBox:
      case cmlTagInputRadio:

        fprintf(ofp, "<Input ");
        if (t8 == cmlTagInputCheckBox)
          fprintf(ofp, " type=checkbox");
        if (t8 == cmlTagInputRadio) {
          fprintf(ofp, " type=radio");
          fprintf(ofp, " group=%ld", varint());
        }

        t8 = getbits(4);
        if (t8 & 4)
          fprintf(ofp, " checked");

        if (t8 & 11) {
          if (t8 & 8) {
            fprintf(ofp, " name=\"");

            if (t8 & 1)
              push("\"");
            if (t8 & 2) {
              push("\">");
              push("\" value=\"");
            }
          } else if (t8 & 2) {
            push("\">");
            fprintf(ofp, " value=\"");
            if (t8 & 1)
              push("");
          } else {
            push(">");
          }

        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputSubmit:
      case cmlTagInputHidden:
        fprintf(ofp, "<Input");

        if (t8 == cmlTagInputSubmit)
          fprintf(ofp, " type=submit");
        if (t8 == cmlTagInputHidden)
          fprintf(ofp, " type=hidden");

        t8 = getbits(2);
        if (t8) {
          if (t8 & 1) {
            fprintf(ofp, " name=\"");
            push("\">");
            if (t8 & 2)
              push("\" value=\"");
          } else {
            fprintf(ofp, " value=\"");
            push("\">");
          }
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputReset:
        fprintf(ofp, "<Input type=reset ");

        if (getbits(1)) {
          fprintf(ofp, " value=\"");
          push("\">");
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputTextArea:
        push("</textarea>");
        fprintf(ofp, "<TextArea");
        fprintf(ofp, " rows=%ld", varint());
        varint();
        fprintf(ofp, " cols=32"); /* doesn't convert right */
        if (getbits(1)) {
          push("\">");
          fprintf(ofp, " name=\"");
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagSelect:
        fprintf(ofp, "<Select ");
        push("</Select>");
        t8 = getbits(2);
        if (t8 & 2)
          fprintf(ofp, " multiple");
        {
          short int i16 = varint();
          fprintf(ofp, " size=%d", i16);
        }
        if (t8 & 1) {
          push("\">");
          fprintf(ofp, " name=\"");
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagSelectItemNormal:
        fprintf(ofp, "<option>");
        push("");
        break;

      case cmlTagSelectItemCustom:
        fprintf(ofp, "<option");
        t8 = getbits(2);
        push("");
        if (t8 & 1)
          fprintf(ofp, " selected");
        if (t8 & 2) {
          fprintf(ofp, " value=\"");
          push("\">");
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputDatePicker:
        fprintf(ofp, "<Input type=date ");
        t8 = getbits(1);
        fprintf(ofp, " value=\"(date)%ld\"", varint());
        if (t8) {
          fprintf(ofp, " name=");
          push(">");
        } else
          fprintf(ofp, ">");
        break;

      case cmlTagInputTimePicker:
        fprintf(ofp, "<Input type=time ");
        t8 = getbits(1);
        fprintf(ofp, " value=\"(time)%ld\"", varint());
        if (t8) {
          fprintf(ofp, " name=");
          push(">");
        } else
          fprintf(ofp, ">");
        break;


      case cmlTagTable:
        fprintf(ofp, "<Table");
        tx = getbits(7);
        if (tx & 1) {
          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " align=left");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " align=center");
            break;
          case cmlAlignRight:
            fprintf(ofp, " align=right");
            break;
          }

        }
        if (tx & 2)
          fprintf(ofp, " width=%ld", varint());
        if (tx & 4)
          fprintf(ofp, " border=%ld", varint());
        if (tx & 8)
          fprintf(ofp, " cellspacing=%ld", varint());
        if (tx & 16)
          fprintf(ofp, " cellpadding=%ld", varint());
        fprintf(ofp, ">");
        push("</table>");
        break;

      case cmlTagCaption:
        fprintf(ofp, "<Caption");
        if (getbits(1))
          fprintf(ofp, " valign=top");
        fprintf(ofp, ">");
        push("</caption>");

        break;
      case cmlTagTableRow:     // 0x30
        fprintf(ofp, "<TR");
        if (getbits(1)) {
          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " align=left");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " align=center");
            break;
          case cmlAlignRight:
            fprintf(ofp, " align=right");
            break;
          }

          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " valign=top");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " valign=middle");
            break;
          case cmlAlignRight:
            fprintf(ofp, " valign=bottom");
            break;
          }
        }
        fprintf(ofp, ">");
        push("</tr>");
        break;

      case cmlTagTableHeader:
      case cmlTagTableData:

        if (t8 == cmlTagTableData) {
          fprintf(ofp, "<TD");
          push("</td>");
        }
        if (t8 == cmlTagTableHeader) {
          fprintf(ofp, "<TH");
          push("</th>");
        }

        tx = getbits(7);
        if (tx & 1) {
          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " align=left");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " align=center");
            break;
          case cmlAlignRight:
            fprintf(ofp, " align=right");
            break;
          }
        }
        if (tx & 2) {
          switch (getbits(2)) {
          case cmlAlignLeft:
            fprintf(ofp, " valign=top");
            break;
          case cmlAlignCenter:
            fprintf(ofp, " valign=middle");
            break;
          case cmlAlignRight:
            fprintf(ofp, " valign=bottom");
            break;
          }
        }

        if (tx & 4)
          fprintf(ofp, " colspan=%ld", varint());
        if (tx & 8)
          fprintf(ofp, " rowspan=%ld", varint());
        if (tx & 16)
          fprintf(ofp, " height=%ld", varint());
        if (tx & 32)
          fprintf(ofp, " width=%ld", varint());

        if (tx & 64)
          fprintf(ofp, " nowrap");

        fprintf(ofp, ">");
        break;


      case cmlTagHyperlink:
        fprintf(ofp, "<A ");
        push("</a>");
        t8 = getbits(2);
        tx = getbits(8);

        if (tx & 1)
          fprintf(ofp, "BUTTON ");

        if (tx & 0x40) {
          if (tx & 8) {
            fprintf(ofp, "href=\"#");
            if (tx & 2)
              push("\" title=\"");
            push("\">");

          } else if (tx & 2) {
            fprintf(ofp, " title=\"");
            push("\">");
          } else
            fprintf(ofp, ">");

        } else if (tx & 4) {
          char edb[64];

          u32 = varint();
          if (tx & 8) {
            strcpy(edb, fname);
            edb[strlen(edb) - 4] = 0;
            fprintf(ofp, " href=\"%s.%03ld.html#", edb, u32);
            if (tx & 2)
              push("\" title=\"");

            push("\">");
          } else if (tx & 2) {
            strcpy(edb, fname);
            edb[strlen(edb) - 4] = 0;
            fprintf(ofp, " href=\"%s.%03ld.html\"", edb, u32);
            fprintf(ofp, " title=\"");
            push("\">");
          } else {
            strcpy(edb, fname);
            edb[strlen(edb) - 4] = 0;
            fprintf(ofp, " href=\"%s.%03ld.html\" >", edb, u32);
          }
        }

        else {
          if (tx & 32) {
            fprintf(ofp, "href=\"");
            if (tx & 2)
              push("\" title=\"");
            push("\">");
          } else {
            fprintf(ofp, "href=index%ld", varint());
            u32 = varint();
            if (tx & 2) {
              fprintf(ofp, " title=\"");
              push("\">");
            } else
              fprintf(ofp, ">");
          }
        }
        break;

      case cmlTagAnchor:
        fprintf(ofp, "<A name=\"");
        push("\"></a>");
        break;

      case cmlTagImage:        // 0x34
        fprintf(ofp, "<Img ");  //Image
        tx = getbits(8);

        if (tx & 128) {
          char edb[64];
          strcpy(edb, fname);
          edb[strlen(edb) - 4] = 0;
          fprintf(ofp, " src=\"%s.%03ld.pgm.gif\"", edb, varint());
        }
        if (tx & 16)
          fprintf(ofp, " vspace=%ld", varint());
        if (tx & 8)
          fprintf(ofp, " hspace=%ld", varint());
        if (tx & 4)
          fprintf(ofp, " border=%ld", varint());
        if (tx & 2) {
          switch (getbits(3)) {
          case cmlIAlignLeft:
            fprintf(ofp, " align=Left");
            break;
          case cmlIAlignRight:
            fprintf(ofp, " align=Right");
            break;
          case cmlIAlignTop:
            fprintf(ofp, " align=Top");
            break;
          case cmlIAlignMiddle:
            fprintf(ofp, " align=Middle");
            break;
          case cmlIAlignBottom:
            fprintf(ofp, " align=Bottom");
            break;
          }
        }
        if (tx & 32) {
          fprintf(ofp, " src=\"");
          push("\">");
          if (tx & 64)
            push("\" alt=\"");
        } else if (tx & 64) {
          fprintf(ofp, " alt=\"");
          push("\">");
        } else
          fprintf(ofp, ">");

        if (tx & 1) {
          //align?
          fprintf(ofp, "<tt><pre>");
          dobitmap();
          fprintf(ofp, "</pre></tt>");
        }
        break;



      case cmlTagHorizontalRule:
        fprintf(ofp, "<HR ");
        t8 = getbits(5);
        if (t8 & 8)
          fprintf(ofp, " noshade");
        switch ((t8 >> 1) & 3) {
        case cmlAlignLeft:
          fprintf(ofp, " align=left");
          break;
        case cmlAlignCenter:
          fprintf(ofp, " align=center");
          break;
        case cmlAlignRight:
          fprintf(ofp, " align=right");
          break;
        }

        if (t8 & 1) {
          fprintf(ofp, " size=%ld", varint());
          if (t8 & 16)
            fprintf(ofp, " width=\"%d%%\"", getbits(8));
          else
            fprintf(ofp, " width=%ld", varint());
        }
        fprintf(ofp, ">");
        break;

      case cmlTagClear:
        fprintf(ofp, "<BR ");
        switch (getbits(2)) {
        case cmlClearLeft:
          fprintf(ofp, " clear=left>");
          break;
        case cmlClearAll:
          fprintf(ofp, " clear=all>");
          break;
        case cmlClearRight:
          fprintf(ofp, " clear=right>");
          break;
        }
        break;

      case cmlTagCMLEnd:
        len = 0;
        while (tsptr > 0)
          fprintf(ofp, "%s\n", tagstk[--tsptr]);
        break;
      }

      break;

    }
  }
}
