#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <time.h>

#pragma pack(2)



extern unsigned char *bp, bitc, ubuf[1024];
extern unsigned short len;

extern FILE *ofp;
void dobitmap();
void dohtml(char *);


void process(char *fname)
{

  FILE *fp;
  char fnbuf1[256], fnbuf2[256];
  unsigned char buf[65536], cont, comp;
  unsigned long ofst, uofst;
  unsigned short int ulen;

  fp = fopen(fname, "rb");

  fread(&ofst, 1, 4, fp);
  uofst = htonl(ofst);
  fread(&len, 1, 2, fp);
  ulen = htons(len);

  fread(&ofst, 1, 4, fp);
  ofst = htonl(ofst);
  fread(&len, 1, 2, fp);
  len = htons(len);
  fread(&cont, 1, 1, fp);
  fread(&comp, 1, 1, fp);

  if (comp != 1 || (cont != 4 && cont != 5)) {
    fclose(fp);
    return;
  }

  fseek(fp, uofst, SEEK_SET);
  fread(ubuf, 1, ulen, fp);
  ubuf[ulen] = 0;

  fseek(fp, ofst, SEEK_SET);
  fread(buf, 1, len, fp);
  fclose(fp);


  bp = buf;
  bitc = 0;

  strcpy(fnbuf1, fname);
  strcpy(fnbuf2, fname);
  fnbuf2[strlen(fnbuf2) - 4] = 0;

  if (cont == 4) {
    strcpy(fnbuf1, fname);

    strcpy(fnbuf2, fname);
    fnbuf2[strlen(fnbuf2) - 4] = 0;

    strcat(fnbuf1, ".html");
    //    symlink( fnbuf1, ubuf );

    fprintf(stdout, "s/%s.pqa\\/%s/%s/g\n", fnbuf2, ubuf, fnbuf1);

    ofp = fopen(fnbuf1, "wb");
    dohtml(fname);
  }

  if (cont == 5) {
    strcat(fnbuf1, ".pgm.gif");

    //      symlink( fnbuf1, ubuf );

    fprintf(stdout, "s/%s.pqa\\/%s/%s/g\n", fnbuf2, ubuf, fnbuf1);

    fnbuf1[strlen(fnbuf1) - 4] = 0;

    ofp = fopen(fnbuf1, "wb");
    dobitmap();
  }

}

#ifndef O_BINARY
#define O_BINARY 0
#endif

#pragma pack(2)

struct prchead {
  char name[32];                //0-32
  short int attr;               //32-33
  short int vers;               //34-35
  long int cr, md, bkt;         //times 36-47
  long int mn, app, sort;       // zero 48-59 - zero for prcs.
  long int type, crea;          //60-67
  long int uidseed, nxrec;      //68-75 - uidseed rand, nxrec zero;
  short int nrecs;              //76-78
} head;

int main(int argc, char *argv[])
{

  unsigned long cofst, xlong, xlong2;
  unsigned char *bbuf;
  long bbuflen;
  int outfd, infd, i, maxsect, argp = 1;
  char title[128];

  if (argc < 2) {
    fprintf(stderr, "Usage: %s prcfile...\n", argv[0]);
    exit(1);
  }

  while (argp < argc) {

    if ((infd = open(argv[argp], O_BINARY | O_RDONLY)) < 1) {
      fprintf(stderr, "Can't open file %s\n", argv[argp]);
      exit(-2);
    }
    if (!(bbuf = malloc(65536)))
      exit(-3);

    if( !strcasecmp( &argv[argp][strlen(argv[argp])-4],".pqa") )
	argv[argp][strlen(argv[argp])-4] = 0;

    read(infd, &head, sizeof(head));
    read(infd, &xlong, 4);

    maxsect = htons(head.nrecs);

    if ((cofst = htonl(head.app))) {
      if (!(bbuflen = htonl(head.sort))) {
        if (maxsect) {
          bbuflen = htonl(xlong);
          bbuflen = bbuflen - cofst;
        } else
          bbuflen = 65534;
      }
      if( bbuflen > 65534 )
	exit(-1);
      //      fprintf(stderr, "appl len: %ld\n", bbuflen);

      xlong2 = lseek(infd, 0, SEEK_CUR);
      lseek(infd, cofst, SEEK_SET);
      bbuflen = read(infd, bbuf, bbuflen);
      lseek(infd, xlong2, SEEK_SET);



      {
	int wptr = 8;

	xlong2 = (bbuf[wptr] * 256 + bbuf[wptr+1]) * 2;
	wptr += 2;
	if( xlong2 ) {
	  sprintf(title, "%s.tver0001.bin", argv[argp]);
	  outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
	  write(outfd, &bbuf[wptr], xlong2);
	  close(outfd);
	}
	wptr += xlong2;
	xlong2 = (bbuf[wptr] * 256 + bbuf[wptr+1]) * 2;
	wptr += 2;
	if( xlong2 ) {
	  sprintf(title, "%s.tAIN03e8.bin", argv[argp]);
	  outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
	  write(outfd, &bbuf[wptr], xlong2);
	  close(outfd);
	}
	wptr += xlong2;
	xlong2 = (bbuf[wptr] * 256 + bbuf[wptr+1]) * 2;
	wptr += 2;
	if( xlong2 ) {

	  bp = &bbuf[wptr]; bitc = 0; len = xlong2;
	  sprintf(title, "%s.icon.pgm", argv[argp]);
	  ofp = fopen(title, "wb");
	  dobitmap();
	  fclose(ofp);

	  sprintf(title, "%s.tAIB03e8.bin", argv[argp]);
	  outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
	  write(outfd, &bbuf[wptr], xlong2);
	  close(outfd);
	}
	wptr += xlong2;
	xlong2 = (bbuf[wptr] * 256 + bbuf[wptr+1]) * 2;
	wptr += 2;
	if( xlong2 ) {

	  bp = &bbuf[wptr]; bitc = 0; len = xlong2;
	  sprintf(title, "%s.smicon.pgm", argv[argp]);
	  ofp = fopen(title, "wb");
	  dobitmap();
	  fclose(ofp);


	  sprintf(title, "%s.tAIB03e9.bin", argv[argp]);
	  outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
	  write(outfd, &bbuf[wptr], xlong2);
	  close(outfd);
	}
	wptr += xlong2;
#if 0
      //extract icons if there
      sprintf(title, "%s.app", argv[argp]);
      outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
      write(outfd, bbuf, bbuflen);
      close(outfd);
#endif
      }

    }

    if ((cofst = htonl(head.sort))) {
      if (maxsect) {
        bbuflen = htonl(xlong);
        bbuflen = bbuflen - cofst;
      } else
        bbuflen = 65534;

      if( bbuflen > 65534 )
	exit(-1);
      //      fprintf(stderr, "sort len: %ld\n", bbuflen);

      xlong2 = lseek(infd, 0, SEEK_CUR);
      lseek(infd, cofst, SEEK_SET);
      bbuflen = read(infd, bbuf, bbuflen);
      lseek(infd, xlong2, SEEK_SET);

      sprintf(title, "%s.srt", argv[argp]);

#if 0
      outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
      write(outfd, bbuf, bbuflen);
      close(outfd);
#endif

    }

    //    fprintf(stderr, "%s %d\n", argv[argp], maxsect);

    cofst = htonl(xlong);

    for (i = 0; i < maxsect; i++) {

      read(infd, title, 4);

      sprintf(title, "%s.%03d", argv[argp], i);


      if (i + 1 != maxsect) {

        read(infd, &xlong2, 4);

        bbuflen = htonl(xlong2);
        bbuflen = bbuflen - cofst;
      } else
        bbuflen = 65534;

      if( bbuflen > 65534 )
	exit(-1);
      xlong = lseek(infd, 0, SEEK_CUR);
      lseek(infd, cofst, SEEK_SET);
      bbuflen = read(infd, bbuf, bbuflen);
      lseek(infd, xlong, SEEK_SET);

      cofst = htonl(xlong2);

      //      fprintf(stderr, "%s %ld\n", title, bbuflen);

      outfd = open(title, O_BINARY | O_RDWR | O_CREAT, 0644);
      write(outfd, bbuf, bbuflen);
      close(outfd);
      process(title);
      unlink(title);
    }
    close(infd);
    argp++;
  }
  return 0;
}
